#ifndef SECUREFWCONSTANTS_H
#define SECUREFWCONSTANTS_H
 
    #define APDU_ONLYONE                            0x01
    #define APDU_MORE_FIRST                         0x02
    #define APDU_MORE_NEXT                          0x03
                                                    
    #define ACCEPTED_CARDS_LENGTH_MAX               0xFF
    #define SLOT_ANY_AVAILABLE                      -1
                                                    
    #define AID_LEN_MAX                             0x10
    #define ALGORITHM_UUID_LENGTH_MAX               0x10
                                                    
    #define CHANNEL_SEC_INFO_LEN                    0x01
                                                    
    #define PIN_SIZE                                0x08
                                                    
    #define SESSION_KEY_LEN                         0x10
    #define HWT_UUID_LENGTH                         0x10
    #define SWA_UUID_LENGTH                         0x10
    #define RANDOM_NONCE_LENGTH                     0x08
    #define MESSAGE_STOP_LENGTH                     0x04

    #define CLA_CARD_DEFAULT                        0xB0
                                                    
    #define INS_CARD_LOGIN    		                0x02
    #define INS_CARD_PROCESS_ALG_DATA               0x03
    #define INS_CARD_LOGOUT		                    0x04
    #define INS_CARD_GET_ALGORITHM_INFO             0x06
                                                    
    #define INS_CARD_PROCESS_MASTER_LICENCE         0x0A
    #define INS_CARD_PROCESS_ALG_LICENCE            0x0B
                                                    
    #define INS_CARD_SEAUT                          0x30
    #define INS_CARD_SEAUT_STOP                     0x31
                                                    
    #define INS_CARD_DEBUG_RESET                    0x40
                                                    
    #define P1_LICENCE_OUTOFORDER                   0xF0
                                                    
    #define INS_CARD_AUTH1                          0x10
    #define INS_CARD_AUTH2                          0x11
    #define INS_CARD_AUTH3                          0x12
    #define INS_CARD_AUTH4                          0x13
                                                    
    #define ALGORITHM_INFO_UUID                     0x01
    #define ALGORITHM_INFO_ALGCOUNT                 0x02
    #define ALGORITHM_INFO_USAGECOUNT               0x03
    #define ALGORITHM_INFO_CHANNEL_SEC              0x04
                                                    
    // CHANNEL SECURITY REQUIEREMENTS               
    #define CHANNEL_SEC_PIN                         0x01
    #define CHANNEL_SEC_APPSECRET                   0x02
    #define CHANNEL_SEC_MAC                         0x04
    #define CHANNEL_SEC_CIPHER                      0x08
 
    // APDU DEBUG FLAGS
    #define FLAG_DEBUG_DISABLE_IOBUFFER_SECURING    0x01    
    #define FLAG_DEBUG_SIMULATE_HARDWARE_AES        0x02    

    // MAX LICENCE LENGTH  
    #define LICENCE_PLAIN_MAX_LENGTH                0xEF
    #define LICENCE_MAX_LENGTH                      0xF0
    #define FILETIME_TO_SECOND                      10000000 
    
    #define APDU_MAX_INPUT_DATA_LEN                 0xFF     // MAXIMUM INPUT DATA BYTES IN ONE APDU
    #define APDU_MAX_OUTPUT_DATA_LEN                0xFF     // MAXIMUM OUTPUT DATA BYTES IN ONE APDU


    #define MD5_DIGEST_LENGTH                       0x10

    #define CLIENT_UUID_LENGTH                      0x10
    #define SERVER_UUID_LENGTH                      0x10
    #define FNC_MAX_IO_DATA_LEN                     0x200   // MAXIMUM LENGTH OF INPUT OR OUTPUT INTO PROTECTED FUNCTION. INCREASE IF NEEDED. 

    const unsigned char MESSAGE_STOP[MESSAGE_STOP_LENGTH] = {0x53, 0x54, 0x4F, 0x50};   //STOP

    #define ACCEPTED_CARDS		"JavaCard\0GXPPro-R3\0"


#endif
